Index: uspace/lib/c/generic/devman.c
===================================================================
--- uspace/lib/c/generic/devman.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/devman.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -77,8 +77,8 @@
  *
  */
-async_exch_t *devman_exchange_begin_blocking(devman_interface_t iface)
+async_exch_t *devman_exchange_begin_blocking(iface_t iface)
 {
 	switch (iface) {
-	case DEVMAN_DRIVER:
+	case INTERFACE_DDF_DRIVER:
 		fibril_mutex_lock(&devman_driver_block_mutex);
 		
@@ -89,6 +89,6 @@
 			if (devman_driver_block_sess == NULL)
 				devman_driver_block_sess =
-				    service_connect_blocking_iface(EXCHANGE_PARALLEL,
-				    DEVMAN_DRIVER, SERVICE_DEVMAN, 0);
+				    service_connect_blocking(SERVICE_DEVMAN,
+				    INTERFACE_DDF_DRIVER, 0);
 		}
 		
@@ -99,5 +99,5 @@
 		
 		return async_exchange_begin(devman_driver_block_sess);
-	case DEVMAN_CLIENT:
+	case INTERFACE_DDF_CLIENT:
 		fibril_mutex_lock(&devman_client_block_mutex);
 		
@@ -108,6 +108,6 @@
 			if (devman_client_block_sess == NULL)
 				devman_client_block_sess =
-				    service_connect_blocking_iface(EXCHANGE_SERIALIZE,
-				    DEVMAN_CLIENT, SERVICE_DEVMAN, 0);
+				    service_connect_blocking(SERVICE_DEVMAN,
+				    INTERFACE_DDF_CLIENT, 0);
 		}
 		
@@ -130,14 +130,14 @@
  *
  */
-async_exch_t *devman_exchange_begin(devman_interface_t iface)
+async_exch_t *devman_exchange_begin(iface_t iface)
 {
 	switch (iface) {
-	case DEVMAN_DRIVER:
+	case INTERFACE_DDF_DRIVER:
 		fibril_mutex_lock(&devman_driver_mutex);
 		
 		if (devman_driver_sess == NULL)
 			devman_driver_sess =
-			    service_connect_iface(EXCHANGE_PARALLEL, DEVMAN_DRIVER,
-			    SERVICE_DEVMAN, 0);
+			    service_connect(SERVICE_DEVMAN,
+			    INTERFACE_DDF_DRIVER, 0);
 		
 		fibril_mutex_unlock(&devman_driver_mutex);
@@ -147,11 +147,11 @@
 		
 		return async_exchange_begin(devman_driver_sess);
-	case DEVMAN_CLIENT:
+	case INTERFACE_DDF_CLIENT:
 		fibril_mutex_lock(&devman_client_mutex);
 		
 		if (devman_client_sess == NULL)
 			devman_client_sess =
-			    service_connect_iface(EXCHANGE_SERIALIZE, DEVMAN_CLIENT,
-			    SERVICE_DEVMAN, 0);
+			    service_connect(SERVICE_DEVMAN,
+			    INTERFACE_DDF_CLIENT, 0);
 		
 		fibril_mutex_unlock(&devman_client_mutex);
@@ -179,5 +179,5 @@
 int devman_driver_register(const char *name)
 {
-	async_exch_t *exch = devman_exchange_begin_blocking(DEVMAN_DRIVER);
+	async_exch_t *exch = devman_exchange_begin_blocking(INTERFACE_DDF_DRIVER);
 	
 	ipc_call_t answer;
@@ -192,6 +192,6 @@
 	}
 	
-	exch = devman_exchange_begin(DEVMAN_DRIVER);
-	async_connect_to_me(exch, 0, 0, 0, NULL, NULL);
+	exch = devman_exchange_begin(INTERFACE_DDF_DRIVER);
+	async_connect_to_me(exch, 0, 0, 0);
 	devman_exchange_end(exch);
 	
@@ -218,5 +218,5 @@
 {
 	int match_count = list_count(&match_ids->ids);
-	async_exch_t *exch = devman_exchange_begin_blocking(DEVMAN_DRIVER);
+	async_exch_t *exch = devman_exchange_begin_blocking(INTERFACE_DDF_DRIVER);
 	
 	ipc_call_t answer;
@@ -268,5 +268,5 @@
     const char *cat_name)
 {
-	async_exch_t *exch = devman_exchange_begin_blocking(DEVMAN_DRIVER);
+	async_exch_t *exch = devman_exchange_begin_blocking(INTERFACE_DDF_DRIVER);
 	
 	ipc_call_t answer;
@@ -287,15 +287,14 @@
 }
 
-async_sess_t *devman_device_connect(exch_mgmt_t mgmt, devman_handle_t handle,
-    unsigned int flags)
+async_sess_t *devman_device_connect(devman_handle_t handle, unsigned int flags)
 {
 	async_sess_t *sess;
 	
 	if (flags & IPC_FLAG_BLOCKING)
-		sess = service_connect_blocking_iface(mgmt, DEVMAN_CONNECT_TO_DEVICE,
-		    SERVICE_DEVMAN, handle);
+		sess = service_connect_blocking(SERVICE_DEVMAN,
+		    INTERFACE_DEVMAN_DEVICE, handle);
 	else
-		sess = service_connect_iface(mgmt, DEVMAN_CONNECT_TO_DEVICE,
-		    SERVICE_DEVMAN, handle);
+		sess = service_connect(SERVICE_DEVMAN,
+		    INTERFACE_DEVMAN_DEVICE, handle);
 	
 	return sess;
@@ -314,5 +313,5 @@
 	sysarg_t retval;
 	
-	exch = devman_exchange_begin_blocking(DEVMAN_DRIVER);
+	exch = devman_exchange_begin_blocking(INTERFACE_DDF_DRIVER);
 	retval = async_req_1_0(exch, DEVMAN_REMOVE_FUNCTION, (sysarg_t) funh);
 	devman_exchange_end(exch);
@@ -323,5 +322,5 @@
 int devman_drv_fun_online(devman_handle_t funh)
 {
-	async_exch_t *exch = devman_exchange_begin(DEVMAN_DRIVER);
+	async_exch_t *exch = devman_exchange_begin(INTERFACE_DDF_DRIVER);
 	if (exch == NULL)
 		return ENOMEM;
@@ -335,5 +334,5 @@
 int devman_drv_fun_offline(devman_handle_t funh)
 {
-	async_exch_t *exch = devman_exchange_begin(DEVMAN_DRIVER);
+	async_exch_t *exch = devman_exchange_begin(INTERFACE_DDF_DRIVER);
 	if (exch == NULL)
 		return ENOMEM;
@@ -345,15 +344,15 @@
 }
 
-async_sess_t *devman_parent_device_connect(exch_mgmt_t mgmt,
-    devman_handle_t handle, unsigned int flags)
+async_sess_t *devman_parent_device_connect(devman_handle_t handle,
+    unsigned int flags)
 {
 	async_sess_t *sess;
 	
 	if (flags & IPC_FLAG_BLOCKING)
-		sess = service_connect_blocking_iface(mgmt,
-			    DEVMAN_CONNECT_TO_PARENTS_DEVICE, SERVICE_DEVMAN, handle);
+		sess = service_connect_blocking(SERVICE_DEVMAN,
+		    INTERFACE_DEVMAN_PARENT, handle);
 	else
-		sess = service_connect_iface(mgmt,
-			    DEVMAN_CONNECT_TO_PARENTS_DEVICE, SERVICE_DEVMAN, handle);
+		sess = service_connect_blocking(SERVICE_DEVMAN,
+		    INTERFACE_DEVMAN_PARENT, handle);
 	
 	return sess;
@@ -366,7 +365,7 @@
 	
 	if (flags & IPC_FLAG_BLOCKING)
-		exch = devman_exchange_begin_blocking(DEVMAN_CLIENT);
+		exch = devman_exchange_begin_blocking(INTERFACE_DDF_CLIENT);
 	else {
-		exch = devman_exchange_begin(DEVMAN_CLIENT);
+		exch = devman_exchange_begin(INTERFACE_DDF_CLIENT);
 		if (exch == NULL)
 			return ENOMEM;
@@ -409,5 +408,5 @@
 	sysarg_t dretval;
 	
-	exch = devman_exchange_begin_blocking(DEVMAN_CLIENT);
+	exch = devman_exchange_begin_blocking(INTERFACE_DDF_CLIENT);
 	
 	ipc_call_t answer;
@@ -474,5 +473,5 @@
 int devman_fun_online(devman_handle_t funh)
 {
-	async_exch_t *exch = devman_exchange_begin(DEVMAN_CLIENT);
+	async_exch_t *exch = devman_exchange_begin(INTERFACE_DDF_CLIENT);
 	if (exch == NULL)
 		return ENOMEM;
@@ -486,5 +485,5 @@
 int devman_fun_offline(devman_handle_t funh)
 {
-	async_exch_t *exch = devman_exchange_begin(DEVMAN_CLIENT);
+	async_exch_t *exch = devman_exchange_begin(INTERFACE_DDF_CLIENT);
 	if (exch == NULL)
 		return ENOMEM;
@@ -499,5 +498,5 @@
     devman_handle_t *handle_buf, size_t buf_size, size_t *act_size)
 {
-	async_exch_t *exch = devman_exchange_begin_blocking(DEVMAN_CLIENT);
+	async_exch_t *exch = devman_exchange_begin_blocking(INTERFACE_DDF_CLIENT);
 
 	ipc_call_t answer;
@@ -578,5 +577,5 @@
 int devman_fun_get_child(devman_handle_t funh, devman_handle_t *devh)
 {
-	async_exch_t *exch = devman_exchange_begin(DEVMAN_CLIENT);
+	async_exch_t *exch = devman_exchange_begin(INTERFACE_DDF_CLIENT);
 	if (exch == NULL)
 		return ENOMEM;
@@ -598,5 +597,5 @@
 int devman_dev_get_parent(devman_handle_t devh, devman_handle_t *funh)
 {
-	async_exch_t *exch = devman_exchange_begin(DEVMAN_CLIENT);
+	async_exch_t *exch = devman_exchange_begin(INTERFACE_DDF_CLIENT);
 	if (exch == NULL)
 		return ENOMEM;
@@ -611,5 +610,5 @@
 int devman_fun_sid_to_handle(service_id_t sid, devman_handle_t *handle)
 {
-	async_exch_t *exch = devman_exchange_begin(DEVMAN_CLIENT);
+	async_exch_t *exch = devman_exchange_begin(INTERFACE_DDF_CLIENT);
 	if (exch == NULL)
 		return ENOMEM;
@@ -639,5 +638,5 @@
 	async_exch_t *exch;
 
-	exch = devman_exchange_begin(DEVMAN_CLIENT);
+	exch = devman_exchange_begin(INTERFACE_DDF_CLIENT);
 	if (exch == NULL)
 		return ENOMEM;
@@ -694,5 +693,5 @@
 {
 	sysarg_t state;
-	async_exch_t *exch = devman_exchange_begin(DEVMAN_CLIENT);
+	async_exch_t *exch = devman_exchange_begin(INTERFACE_DDF_CLIENT);
 	if (exch == NULL)
 		return ENOMEM;
@@ -711,5 +710,5 @@
 int devman_driver_load(devman_handle_t drvh)
 {
-	async_exch_t *exch = devman_exchange_begin(DEVMAN_CLIENT);
+	async_exch_t *exch = devman_exchange_begin(INTERFACE_DDF_CLIENT);
 	if (exch == NULL)
 		return ENOMEM;
Index: uspace/lib/c/generic/dhcp.c
===================================================================
--- uspace/lib/c/generic/dhcp.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/dhcp.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -56,5 +56,5 @@
 		return ENOENT;
 
-	dhcp_sess = loc_service_connect(EXCHANGE_SERIALIZE, dhcp_svc,
+	dhcp_sess = loc_service_connect(dhcp_svc, INTERFACE_DHCP,
 	    IPC_FLAG_BLOCKING);
 	if (dhcp_sess == NULL)
Index: uspace/lib/c/generic/dnsr.c
===================================================================
--- uspace/lib/c/generic/dnsr.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/dnsr.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -52,5 +52,5 @@
 		    IPC_FLAG_BLOCKING);
 		
-		dnsr_sess = loc_service_connect(EXCHANGE_SERIALIZE, dnsr_svc,
+		dnsr_sess = loc_service_connect(dnsr_svc, INTERFACE_DNSR,
 		    IPC_FLAG_BLOCKING);
 	}
Index: uspace/lib/c/generic/inet.c
===================================================================
--- uspace/lib/c/generic/inet.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/inet.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -48,5 +48,9 @@
 	ipc_call_t answer;
 	aid_t req = async_send_0(exch, INET_CALLBACK_CREATE, &answer);
-	int rc = async_connect_to_me(exch, 0, 0, 0, inet_cb_conn, NULL);
+	
+	port_id_t port;
+	int rc = async_create_callback_port(exch, INTERFACE_INET_CB, 0, 0,
+	    inet_cb_conn, NULL, &port);
+	
 	async_exchange_end(exch);
 	
@@ -83,5 +87,5 @@
 		return ENOENT;
 	
-	inet_sess = loc_service_connect(EXCHANGE_SERIALIZE, inet_svc,
+	inet_sess = loc_service_connect(inet_svc, INTERFACE_INET,
 	    IPC_FLAG_BLOCKING);
 	if (inet_sess == NULL)
Index: uspace/lib/c/generic/inet/tcp.c
===================================================================
--- uspace/lib/c/generic/inet/tcp.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/inet/tcp.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -112,5 +112,5 @@
 	}
 
-	tcp->sess = loc_service_connect(EXCHANGE_SERIALIZE, tcp_svcid,
+	tcp->sess = loc_service_connect(tcp_svcid, INTERFACE_TCP,
 	    IPC_FLAG_BLOCKING);
 	if (tcp->sess == NULL) {
Index: uspace/lib/c/generic/inet/udp.c
===================================================================
--- uspace/lib/c/generic/inet/udp.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/inet/udp.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -98,5 +98,5 @@
 	}
 
-	udp->sess = loc_service_connect(EXCHANGE_SERIALIZE, udp_svcid,
+	udp->sess = loc_service_connect(udp_svcid, INTERFACE_UDP,
 	    IPC_FLAG_BLOCKING);
 	if (udp->sess == NULL) {
Index: uspace/lib/c/generic/inetcfg.c
===================================================================
--- uspace/lib/c/generic/inetcfg.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/inetcfg.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -120,10 +120,10 @@
 	assert(inetcfg_sess == NULL);
 	
-	rc = loc_service_get_id(SERVICE_NAME_INETCFG, &inet_svc,
+	rc = loc_service_get_id(SERVICE_NAME_INET, &inet_svc,
 	    IPC_FLAG_BLOCKING);
 	if (rc != EOK)
 		return ENOENT;
 	
-	inetcfg_sess = loc_service_connect(EXCHANGE_SERIALIZE, inet_svc,
+	inetcfg_sess = loc_service_connect(inet_svc, INTERFACE_INETCFG,
 	    IPC_FLAG_BLOCKING);
 	if (inetcfg_sess == NULL)
Index: uspace/lib/c/generic/inetping.c
===================================================================
--- uspace/lib/c/generic/inetping.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/inetping.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -53,10 +53,10 @@
 	inetping_ev_ops = ev_ops;
 
-	rc = loc_service_get_id(SERVICE_NAME_INETPING, &inetping_svc,
+	rc = loc_service_get_id(SERVICE_NAME_INET, &inetping_svc,
 	    IPC_FLAG_BLOCKING);
 	if (rc != EOK)
 		return ENOENT;
 
-	inetping_sess = loc_service_connect(EXCHANGE_SERIALIZE, inetping_svc,
+	inetping_sess = loc_service_connect(inetping_svc, INTERFACE_INETPING,
 	    IPC_FLAG_BLOCKING);
 	if (inetping_sess == NULL)
@@ -65,5 +65,8 @@
 	async_exch_t *exch = async_exchange_begin(inetping_sess);
 
-	rc = async_connect_to_me(exch, 0, 0, 0, inetping_cb_conn, NULL);
+	port_id_t port;
+	rc = async_create_callback_port(exch, INTERFACE_INETPING_CB, 0, 0,
+	    inetping_cb_conn, NULL, &port);
+	
 	async_exchange_end(exch);
 
Index: uspace/lib/c/generic/io/console.c
===================================================================
--- uspace/lib/c/generic/io/console.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/io/console.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -49,5 +49,5 @@
 		return NULL;
 	
-	ctrl->input_sess = fsession(EXCHANGE_SERIALIZE, ifile);
+	ctrl->input_sess = fsession(ifile, INTERFACE_CONSOLE);
 	if (!ctrl->input_sess) {
 		free(ctrl);
@@ -55,5 +55,5 @@
 	}
 	
-	ctrl->output_sess = fsession(EXCHANGE_SERIALIZE, ofile);
+	ctrl->output_sess = fsession(ofile, INTERFACE_CONSOLE);
 	if (!ctrl->output_sess) {
 		free(ctrl);
Index: uspace/lib/c/generic/io/input.c
===================================================================
--- uspace/lib/c/generic/io/input.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/io/input.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -58,5 +58,8 @@
 	async_exch_t *exch = async_exchange_begin(sess);
 
-	int rc = async_connect_to_me(exch, 0, 0, 0, input_cb_conn, input);
+	port_id_t port;
+	int rc = async_create_callback_port(exch, INTERFACE_INPUT_CB, 0, 0,
+	    input_cb_conn, input, &port);
+	
 	async_exchange_end(exch);
 
Index: uspace/lib/c/generic/io/io.c
===================================================================
--- uspace/lib/c/generic/io/io.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/io/io.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -748,9 +748,9 @@
 }
 
-async_sess_t *fsession(exch_mgmt_t mgmt, FILE *stream)
+async_sess_t *fsession(FILE *stream, iface_t iface)
 {
 	if (stream->fd >= 0) {
 		if (stream->sess == NULL)
-			stream->sess = fd_session(mgmt, stream->fd);
+			stream->sess = fd_session(stream->fd, iface);
 		
 		return stream->sess;
Index: uspace/lib/c/generic/io/log.c
===================================================================
--- uspace/lib/c/generic/io/log.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/io/log.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -166,6 +166,6 @@
 		return ENOMEM;
 
-	logger_session = service_connect_blocking_iface(EXCHANGE_SERIALIZE,
-	    LOGGER_INTERFACE_WRITER, SERVICE_LOGGER, 0);
+	logger_session = service_connect_blocking(SERVICE_LOGGER,
+	    INTERFACE_LOGGER_WRITER, 0);
 	if (logger_session == NULL) {
 		return ENOMEM;
Index: uspace/lib/c/generic/io/logctl.c
===================================================================
--- uspace/lib/c/generic/io/logctl.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/io/logctl.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -48,6 +48,6 @@
 
 	if (logger_session == NULL) {
-		logger_session = service_connect_blocking_iface(EXCHANGE_SERIALIZE,
-		    LOGGER_INTERFACE_CONTROL, SERVICE_LOGGER, 0);
+		logger_session = service_connect_blocking(SERVICE_LOGGER,
+		    INTERFACE_LOGGER_CONTROL, 0);
 		if (logger_session == NULL)
 			return ENOMEM;
Index: uspace/lib/c/generic/iplink.c
===================================================================
--- uspace/lib/c/generic/iplink.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/iplink.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -59,6 +59,9 @@
 	
 	async_exch_t *exch = async_exchange_begin(sess);
-	
-	int rc = async_connect_to_me(exch, 0, 0, 0, iplink_cb_conn, iplink);
+
+	port_id_t port;
+	int rc = async_create_callback_port(exch, INTERFACE_IPLINK_CB, 0, 0,
+	    iplink_cb_conn, iplink, &port);
+	
 	async_exchange_end(exch);
 	
Index: uspace/lib/c/generic/irc.c
===================================================================
--- uspace/lib/c/generic/irc.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/irc.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -51,6 +51,5 @@
 	assert(irc_sess == NULL);
 
-	irc_sess = service_connect_blocking(EXCHANGE_SERIALIZE,
-	    SERVICE_IRC, 0);
+	irc_sess = service_connect_blocking(SERVICE_IRC, INTERFACE_IRC, 0);
 
 	if (irc_sess == NULL)
Index: uspace/lib/c/generic/loader.c
===================================================================
--- uspace/lib/c/generic/loader.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/loader.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -69,6 +69,5 @@
 	
 	async_sess_t *sess =
-	    service_connect_blocking_iface_extended(SERVICE_LOADER,
-	    INTERFACE_LOADER, 0);
+	    service_connect_blocking(SERVICE_LOADER, INTERFACE_LOADER, 0);
 	if (sess == NULL) {
 		free(ldr);
Index: uspace/lib/c/generic/loc.c
===================================================================
--- uspace/lib/c/generic/loc.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/loc.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -107,9 +107,13 @@
 	if (!loc_callback_created) {
 		async_exch_t *exch =
-		    loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+		    loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 		
 		ipc_call_t answer;
 		aid_t req = async_send_0(exch, LOC_CALLBACK_CREATE, &answer);
-		int rc = async_connect_to_me(exch, 0, 0, 0, loc_cb_conn, NULL);
+		
+		port_id_t port;
+		int rc = async_create_callback_port(exch, INTERFACE_LOC_CB, 0, 0,
+		    loc_cb_conn, NULL, &port);
+		
 		loc_exchange_end(exch);
 		
@@ -135,8 +139,8 @@
  *
  */
-async_exch_t *loc_exchange_begin_blocking(loc_interface_t iface)
+async_exch_t *loc_exchange_begin_blocking(iface_t iface)
 {
 	switch (iface) {
-	case LOC_PORT_SUPPLIER:
+	case INTERFACE_LOC_SUPPLIER:
 		fibril_mutex_lock(&loc_supp_block_mutex);
 		
@@ -147,6 +151,6 @@
 			if (loc_supp_block_sess == NULL)
 				loc_supp_block_sess =
-				    service_connect_blocking_iface(EXCHANGE_SERIALIZE,
-				    LOC_PORT_SUPPLIER, SERVICE_LOC, 0);
+				    service_connect_blocking(SERVICE_LOC,
+				    INTERFACE_LOC_SUPPLIER, 0);
 		}
 		
@@ -157,5 +161,5 @@
 		
 		return async_exchange_begin(loc_supp_block_sess);
-	case LOC_PORT_CONSUMER:
+	case INTERFACE_LOC_CONSUMER:
 		fibril_mutex_lock(&loc_cons_block_mutex);
 		
@@ -166,6 +170,6 @@
 			if (loc_cons_block_sess == NULL)
 				loc_cons_block_sess =
-				    service_connect_blocking_iface(EXCHANGE_SERIALIZE,
-				    LOC_PORT_CONSUMER, SERVICE_LOC, 0);
+				    service_connect_blocking(SERVICE_LOC,
+				    INTERFACE_LOC_CONSUMER, 0);
 		}
 		
@@ -188,14 +192,14 @@
  *
  */
-async_exch_t *loc_exchange_begin(loc_interface_t iface)
+async_exch_t *loc_exchange_begin(iface_t iface)
 {
 	switch (iface) {
-	case LOC_PORT_SUPPLIER:
+	case INTERFACE_LOC_SUPPLIER:
 		fibril_mutex_lock(&loc_supplier_mutex);
 		
 		if (loc_supplier_sess == NULL)
 			loc_supplier_sess =
-			    service_connect_iface(EXCHANGE_SERIALIZE, LOC_PORT_SUPPLIER,
-			    SERVICE_LOC, 0);
+			    service_connect(SERVICE_LOC,
+			    INTERFACE_LOC_SUPPLIER, 0);
 		
 		fibril_mutex_unlock(&loc_supplier_mutex);
@@ -205,11 +209,11 @@
 		
 		return async_exchange_begin(loc_supplier_sess);
-	case LOC_PORT_CONSUMER:
+	case INTERFACE_LOC_CONSUMER:
 		fibril_mutex_lock(&loc_consumer_mutex);
 		
 		if (loc_consumer_sess == NULL)
 			loc_consumer_sess =
-			    service_connect_iface(EXCHANGE_SERIALIZE, LOC_PORT_CONSUMER,
-			    SERVICE_LOC, 0);
+			    service_connect(SERVICE_LOC,
+			    INTERFACE_LOC_CONSUMER, 0);
 		
 		fibril_mutex_unlock(&loc_consumer_mutex);
@@ -237,5 +241,5 @@
 int loc_server_register(const char *name)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(LOC_PORT_SUPPLIER);
+	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_SUPPLIER);
 	
 	ipc_call_t answer;
@@ -250,6 +254,6 @@
 	}
 	
-	exch = loc_exchange_begin(LOC_PORT_SUPPLIER);
-	async_connect_to_me(exch, 0, 0, 0, NULL, NULL);
+	exch = loc_exchange_begin(INTERFACE_LOC_SUPPLIER);
+	async_connect_to_me(exch, 0, 0, 0);
 	loc_exchange_end(exch);
 	
@@ -260,24 +264,14 @@
 /** Register new service.
  *
- * The @p interface is used when forwarding connection to the server.
- * If not 0, the first argument is the interface and the second argument
- * is the service ID.
- *
- * When the interface is zero (default), the first argument is directly
- * the handle (to ensure backward compatibility).
- *
- * @param      fqsn      Fully qualified service name
- * @param[out] sid       Service ID of new service
- * @param      interface Interface when forwarding
- *
- */
-int loc_service_register_with_iface(const char *fqsn,
-    service_id_t *sid, sysarg_t interface)
-{
-	async_exch_t *exch = loc_exchange_begin_blocking(LOC_PORT_SUPPLIER);
+ * @param      fqsn  Fully qualified service name
+ * @param[out] sid   Service ID of new service
+ *
+ */
+int loc_service_register(const char *fqsn, service_id_t *sid)
+{
+	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_SUPPLIER);
 	
 	ipc_call_t answer;
-	aid_t req = async_send_2(exch, LOC_SERVICE_REGISTER, interface, 0,
-	    &answer);
+	aid_t req = async_send_0(exch, LOC_SERVICE_REGISTER, &answer);
 	sysarg_t retval = async_data_write_start(exch, fqsn, str_size(fqsn));
 	
@@ -304,15 +298,4 @@
 }
 
-/** Register new service.
- *
- * @param fqsn Fully qualified service name
- * @param sid  Output: ID of new service
- *
- */
-int loc_service_register(const char *fqdn, service_id_t *sid)
-{
-	return loc_service_register_with_iface(fqdn, sid, 0);
-}
-
 /** Unregister service.
  *
@@ -324,5 +307,5 @@
 	sysarg_t retval;
 	
-	exch = loc_exchange_begin_blocking(LOC_PORT_SUPPLIER);
+	exch = loc_exchange_begin_blocking(INTERFACE_LOC_SUPPLIER);
 	retval = async_req_1_0(exch, LOC_SERVICE_UNREGISTER, sid);
 	loc_exchange_end(exch);
@@ -337,7 +320,7 @@
 	
 	if (flags & IPC_FLAG_BLOCKING)
-		exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+		exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 	else {
-		exch = loc_exchange_begin(LOC_PORT_CONSUMER);
+		exch = loc_exchange_begin(INTERFACE_LOC_CONSUMER);
 		if (exch == NULL)
 			return errno;
@@ -390,5 +373,5 @@
 	
 	*name = NULL;
-	exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+	exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 	
 	ipc_call_t answer;
@@ -470,7 +453,7 @@
 	
 	if (flags & IPC_FLAG_BLOCKING)
-		exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+		exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 	else {
-		exch = loc_exchange_begin(LOC_PORT_CONSUMER);
+		exch = loc_exchange_begin(INTERFACE_LOC_CONSUMER);
 		if (exch == NULL)
 			return errno;
@@ -519,7 +502,7 @@
 	
 	if (flags & IPC_FLAG_BLOCKING)
-		exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+		exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 	else {
-		exch = loc_exchange_begin(LOC_PORT_CONSUMER);
+		exch = loc_exchange_begin(INTERFACE_LOC_CONSUMER);
 		if (exch == NULL)
 			return errno;
@@ -556,5 +539,5 @@
 loc_object_type_t loc_id_probe(service_id_t handle)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 	
 	sysarg_t type;
@@ -569,5 +552,5 @@
 }
 
-async_sess_t *loc_service_connect_iface(service_id_t handle, iface_t iface,
+async_sess_t *loc_service_connect(service_id_t handle, iface_t iface,
     unsigned int flags)
 {
@@ -575,29 +558,14 @@
 	
 	if (flags & IPC_FLAG_BLOCKING)
-		sess = service_connect_blocking_iface_extended(SERVICE_LOC, iface, handle);
+		sess = service_connect_blocking(SERVICE_LOC, iface, handle);
 	else
-		sess = service_connect_iface_extended(SERVICE_LOC, iface, handle);
+		sess = service_connect(SERVICE_LOC, iface, handle);
 	
 	return sess;
 }
 
-async_sess_t *loc_service_connect(exch_mgmt_t mgmt, service_id_t handle,
-    unsigned int flags)
-{
-	async_sess_t *sess;
-	
-	if (flags & IPC_FLAG_BLOCKING)
-		sess = service_connect_blocking_iface(mgmt, LOC_CONNECT_TO_SERVICE,
-		    SERVICE_LOC, handle);
-	else
-		sess = service_connect_iface(mgmt, LOC_CONNECT_TO_SERVICE,
-		    SERVICE_LOC, handle);
-	
-	return sess;
-}
-
 int loc_null_create(void)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 	
 	sysarg_t null_id;
@@ -614,5 +582,5 @@
 void loc_null_destroy(int null_id)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 	async_req_1_0(exch, LOC_NULL_DESTROY, (sysarg_t) null_id);
 	loc_exchange_end(exch);
@@ -640,5 +608,5 @@
 	sysarg_t retval;
 	
-	exch = loc_exchange_begin_blocking(LOC_PORT_SUPPLIER);
+	exch = loc_exchange_begin_blocking(INTERFACE_LOC_SUPPLIER);
 	retval = async_req_2_0(exch, LOC_SERVICE_ADD_TO_CAT, svc_id, cat_id);
 	loc_exchange_end(exch);
@@ -661,5 +629,5 @@
 size_t loc_count_namespaces(void)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 	size_t size = loc_count_namespaces_internal(exch);
 	loc_exchange_end(exch);
@@ -670,5 +638,5 @@
 size_t loc_count_services(service_id_t ns_handle)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 	size_t size = loc_count_services_internal(exch, ns_handle);
 	loc_exchange_end(exch);
@@ -681,5 +649,5 @@
 	/* Loop until read is succesful */
 	while (true) {
-		async_exch_t *exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+		async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 		size_t count = loc_count_namespaces_internal(exch);
 		loc_exchange_end(exch);
@@ -692,5 +660,5 @@
 			return 0;
 		
-		exch = loc_exchange_begin(LOC_PORT_CONSUMER);
+		exch = loc_exchange_begin(INTERFACE_LOC_CONSUMER);
 		
 		ipc_call_t answer;
@@ -730,5 +698,5 @@
 	/* Loop until read is succesful */
 	while (true) {
-		async_exch_t *exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+		async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 		size_t count = loc_count_services_internal(exch, ns_handle);
 		loc_exchange_end(exch);
@@ -741,5 +709,5 @@
 			return 0;
 		
-		exch = loc_exchange_begin(LOC_PORT_CONSUMER);
+		exch = loc_exchange_begin(INTERFACE_LOC_CONSUMER);
 		
 		ipc_call_t answer;
@@ -778,5 +746,5 @@
     sysarg_t *id_buf, size_t buf_size, size_t *act_size)
 {
-	async_exch_t *exch = loc_exchange_begin_blocking(LOC_PORT_CONSUMER);
+	async_exch_t *exch = loc_exchange_begin_blocking(INTERFACE_LOC_CONSUMER);
 
 	ipc_call_t answer;
Index: uspace/lib/c/generic/ns.c
===================================================================
--- uspace/lib/c/generic/ns.c	(revision 0dd16778197e5f50b6e77a71d9b8aeb33b2ad863)
+++ uspace/lib/c/generic/ns.c	(revision f9b2cb4cf365498e1fe141b1aa66950fbc3dcb17)
@@ -43,5 +43,5 @@
 {
 	async_exch_t *exch = async_exchange_begin(session_ns);
-	int rc = async_connect_to_me(exch, 0, service, 0, NULL, NULL);
+	int rc = async_connect_to_me(exch, 0, service, 0);
 	async_exchange_end(exch);
 	
@@ -49,30 +49,6 @@
 }
 
-async_sess_t *service_connect_iface(exch_mgmt_t mgmt, sysarg_t iface,
-    service_t service, sysarg_t arg3)
-{
-	async_exch_t *exch = async_exchange_begin(session_ns);
-	if (!exch)
-		return NULL;
-	
-	async_sess_t *sess =
-	    async_connect_me_to(mgmt, exch, iface, service, arg3);
-	async_exchange_end(exch);
-	
-	if (!sess)
-		return NULL;
-	
-	/*
-	 * FIXME Ugly hack to work around limitation of implementing
-	 * parallel exchanges using multiple connections. Shift out
-	 * first argument for non-initial connections.
-	 */
-	async_sess_args_set(sess, iface, arg3, 0);
-	
-	return sess;
-}
 
-async_sess_t *service_connect_iface_extended(service_t service, iface_t iface,
-    sysarg_t arg3)
+async_sess_t *service_connect(service_t service, iface_t iface, sysarg_t arg3)
 {
 	async_exch_t *exch = async_exchange_begin(session_ns);
@@ -97,52 +73,6 @@
 }
 
-async_sess_t *service_connect(exch_mgmt_t mgmt, service_t service, sysarg_t arg3)
-{
-	async_exch_t *exch = async_exchange_begin(session_ns);
-	if (!exch)
-		return NULL;
-	
-	async_sess_t *sess =
-	    async_connect_me_to(mgmt, exch, 0, service, arg3);
-	async_exchange_end(exch);
-	
-	if (!sess)
-		return NULL;
-	
-	/*
-	 * FIXME Ugly hack to work around limitation of implementing
-	 * parallel exchanges using multiple connections. Shift out
-	 * first argument for non-initial connections.
-	 */
-	async_sess_args_set(sess, 0, arg3, 0);
-	
-	return sess;
-}
-
-async_sess_t *service_connect_blocking_iface(exch_mgmt_t mgmt, sysarg_t iface,
-    service_t service, sysarg_t arg3)
-{
-	async_exch_t *exch = async_exchange_begin(session_ns);
-	if (!exch)
-		return NULL;
-	async_sess_t *sess =
-	    async_connect_me_to_blocking(mgmt, exch, iface, service, arg3);
-	async_exchange_end(exch);
-	
-	if (!sess)
-		return NULL;
-	
-	/*
-	 * FIXME Ugly hack to work around limitation of implementing
-	 * parallel exchanges using multiple connections. Shift out
-	 * first argument for non-initial connections.
-	 */
-	async_sess_args_set(sess, iface, arg3, 0);
-	
-	return sess;
-}
-
-async_sess_t *service_connect_blocking_iface_extended(service_t service,
-    iface_t iface, sysarg_t arg3)
+async_sess_t *service_connect_blocking(service_t service, iface_t iface,
+    sysarg_t arg3)
 {
 	async_exch_t *exch = async_exchange_begin(session_ns);
@@ -164,59 +94,4 @@
 }
 
-async_sess_t *service_connect_blocking(exch_mgmt_t mgmt, service_t service,
-    sysarg_t arg3)
-{
-	async_exch_t *exch = async_exchange_begin(session_ns);
-	async_sess_t *sess =
-	    async_connect_me_to_blocking(mgmt, exch, 0, service, arg3);
-	async_exchange_end(exch);
-	
-	if (!sess)
-		return NULL;
-	
-	/*
-	 * FIXME Ugly hack to work around limitation of implementing
-	 * parallel exchanges using multiple connections. Shift out
-	 * first argument for non-initial connections.
-	 */
-	async_sess_args_set(sess, 0, arg3, 0);
-	
-	return sess;
-}
-
-/** Create bidirectional connection with a service
- *
- * @param[in] service         Service.
- * @param[in] arg1            First parameter.
- * @param[in] arg2            Second parameter.
- * @param[in] arg3            Third parameter.
- * @param[in] client_receiver Message receiver.
- *
- * @return Session to the service.
- * @return Other error codes as defined by async_connect_to_me().
- *
- */
-async_sess_t *service_bind(service_t service, sysarg_t arg1, sysarg_t arg2,
-    sysarg_t arg3, async_port_handler_t client_receiver)
-{
-	/* Connect to the needed service */
-	async_sess_t *sess =
-	    service_connect_blocking(EXCHANGE_SERIALIZE, service, 0);
-	if (sess != NULL) {
-		/* Request callback connection */
-		async_exch_t *exch = async_exchange_begin(sess);
-		int rc = async_connect_to_me(exch, arg1, arg2, arg3,
-		    client_receiver, NULL);
-		async_exchange_end(exch);
-		
-		if (rc != EOK) {
-			async_hangup(sess);
-			errno = rc;
-			return NULL;
-		}
-	}
-	
-	return sess;
-}
 
 int ns_ping(void)
